# -*- coding: utf-8 -*-
##----------------------------------------------------------------------
## Eltex.MES.add_staticvlan
##----------------------------------------------------------------------
## Copyright (C) 2007-2011 The NOC Project
## See LICENSE for details
##----------------------------------------------------------------------

## Python modules
from __future__ import with_statement
## NOC modules
from noc.sa.script import Script as NOCScript
from noc.sa.interfaces import IAddStaticVlan

class Script(NOCScript):
    name = "Eltex.MES.add_staticvlan"
    implements = [IAddStaticVlan]

    def execute(self,vlan,name,tagged=[],untagged=[],advertisement=False):
        a = ''
        if not self.scripts.has_vlan(vlan_id=vlan):
            a = 1;
            if tagged:
                ports = ''
                for port in tagged:
                    if ports:
                        ports = ports + ',' + port
                    else:
                        ports = port
                tagged = ports
            if untagged:
                ports = ''
                for port in untagged:
                    if ports:
                        ports = ports + ',' + port
                    else:
                        ports = port
                untagged = ports

        # Try snmp first
# Not implamented in NOC snmp?
#        if self.snmp and self.access_profile.snmp_rw:
#            try:
#                if a:
#                    self.snmp.set("1.3.6.1.2.1.17.7.1.4.3.1.1.%s"%vlan = name)
#                    self.snmp.set("1.3.6.1.2.1.17.7.1.4.3.1.5.%s"%vlan = 1) # = 4
#                if tagged:
#                    self.snmp.set("1.3.6.1.2.1.17.7.1.4.3.1.1.%s"%vlan = tagged)
#                if untagged:
#                    self.snmp.set("1.3.6.1.2.1.17.7.1.4.3.1.1.%s"%vlan = untagged)
#           except self.snmp.TimeOutError:
#               pass

        # Fallback to CLI
        with self.configure():
            if a:
                self.cli("vlan database")
                self.cli("vlan %d"%vlan)
                self.cli("exit")
                self.cli("interface vlan %d"%vlan)
                self.cli("name %s"%name)
                self.cli("exit")
### Don't implemented, may be in future firmware revisions ?
#               if advertisement:
#                   self.cli("config vlan %s advertisement enable"%(name))
            if tagged:
                self.cli("interface range %s"%tagged)
### 802.1q
#                self.cli("switchport general allowed vlan add %d tagged"%vlan)
## trunk
                self.cli("switchport trunk allowed vlan add  %d"%vlan)
            if untagged:
                self.cli("interface range %s"%untagged)
## 802.1q
#                self.cli("switchport general allowed vlan add %d untagged"%vlan)
### trunk
                self.cli("switchport trunk native vlan %d"%vlan)
            self.cli("exit")
#        self.save_config()
        return True
