# -*- coding: utf-8 -*-
##----------------------------------------------------------------------
## Eltex.MES.set_switchports
##----------------------------------------------------------------------
## Copyright (C) 2007-2011 The NOC Project
## See LICENSE for details
##----------------------------------------------------------------------

## Python modules
from __future__ import with_statement
## NOC modules
from noc.sa.script import Script as NOCScript
from noc.sa.interfaces import ISetSwitchPorts

class Script(NOCScript):
    name = "Eltex.MES.set_switchports"
    implements = [ISetSwitchPorts]

    def execute(self,ports,speed="auto",flow_control="disable",state="enable",description=None):
        with self.configure():
            self.cli("interface range %s"%ports)
            if speed == "auto":
                self.cli("no speed")
            else:
                self.cli("speed %s"%speed)

            if flow_control == "disable":
                self.cli("no flowcontrol")
            else:
                self.cli("flowcontrol %s"%flow_control)

            if description:
                self.cli("description %s"%description)
            else:
                self.cli("no description")

            if state == "enable":
                self.cli("no shutdown")
            elif state == "disable":
                self.cli("shutdown")
#        self.save_config()
        return True
